# Copyright (c) 2020  University of Houston

# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

from __future__ import absolute_import

class GraderError(Exception):
  def __init__ (self, code):
    super(GraderError, self).__init__()
    self.code = code
    self.msg = ""

  def __str__ (self):
    return "<GraderError [%d]: %s>" % (self.code, self.msg)

  def __json__ (self):
    return {"retcode" : self.code, "msg" : self.msg, "value" : None}


class UnableToResolveMACError(GraderError):
  def __init__ (self):
    super(UnableToResolveMACError, self).__init__(1)
    

class SourcePortNotFoundError(GraderError):
  def __init__ (self, ip, host):
    super(SourcePortNotFoundError, self).__init__(2)
    self.ip = ip
    self.host = host
    self.msg = "Host '%s' has no interface whose subnet contains the IP '%s'" % (self.host, self.ip)
