# Copyright (c) 2017-2020  University of Houston Networking Lab

import os
import os.path
from setuptools import setup, find_packages

service_require = [
  "geni-lib",
  "graphviz",
  "dpkt",
  "uh-geni-support",
]

setup(name = "uh-grader",
      version = "0.2",
      author = "UH Networking Lab",
      author_email = "netlab@uh.edu",
      packages = find_packages(),
      scripts = ['bin/grader', 'bin/grader-client'],
      install_requires = [
        "Flask",
        "IPy",
        "python-dateutil",
        "six",
        "uhnet-utils",
        ],
      extras_require = { "service" : service_require },
      classifiers = [
        "Programming Language :: Python :: 2.7",
        "Programming Language :: Python :: 3.6",
        ],
      )
