# Copyright (c) 2019-2020  University of Houston Networking Lab

from __future__ import absolute_import

import dpkt
import six

import uhnet.pcap.eth
import uhnet.pcap.arp

def buildEthHeaderList (pcap_stream):
  tlist = []
  fl = six.BytesIO(pcap_stream)

  reader = dpkt.pcap.Reader(fl)
  for (ts,data) in reader:
    obj = uhnet.pcap.eth.parse(data)
    if obj["type"] < 1501:
      obj["type"] = "%d (length)" % (obj["type"])
    else:
      obj["type"] = "0x%04x" % (obj["type"])
    if obj["tpid"]:
      obj["tpid"] = "0x%04x" % (obj["tpid"])
    tlist.append(obj)

  return tlist


def buildARPHeaderList (pcap_stream):
  l2list = buildEthHeaderList(pcap_stream)
  for pobj in l2list:
    uhnet.pcap.arp.parse(pobj)
  return l2list

