# Copyright (c) 2021  University of Houston Networking Lab

# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

from __future__ import absolute_import

from flask import request

import six

from .exceptions import LabserveError
from .json import jsonify_ephemeral as jsonify
from .json import jsonValidate
from .restapi import Dispatcher, route

if six.PY3:
  unicode = str

class AdminServer(Dispatcher):
  def __init__ (self, labsvc, app):
    super(AdminServer, self).__init__("Admin Service", app.logger, app)
    self._labsvc = labsvc
    self._db = labsvc._db

  def validate (self, rjson, types):
    return jsonValidate(rjson, types, self._log)

  @route('/admin/course/name/<cname>/user/<shortuid>', methods=["PUT", "DELETE"])
  def adminCourseUserManage (self, cname, shortuid):
    course = self._db._courses[cname]

    if request.method == "DELETE":
      course.removeUserID(shortuid)
    elif request.method == "PUT":
      course.addUserID(shortuid)

    self._db._writeUserCourse()
    return jsonify(True)

