# Copyright (c) 2019  University of Houston Networking Lab

# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

from __future__ import absolute_import

import uuid

from .datafile import DataFile

class AnswerKey(DataFile):
  EXTENSION='.akey'

  def __init__ (self):
    super(AnswerKey, self).__init__()
    self.uuid = str(uuid.uuid4())
    self.version = 1
    self.info = None
    self.answers = None

  def __json_ephemeral__(self):
    return self.answers

  def __json__ (self):
    obj = {}
    obj['uuid'] = self.uuid
    obj['version'] = self.version
    obj['info'] = self.info
    obj['answers'] = self.answers
    return obj

  @classmethod
  def jconstruct (cls, obj):
    ans = cls()
    ans.answers = obj['answers']
    ans.info = obj['info']
    if 'uuid' in obj:
      ans.uuid = obj['uuid']
    if 'version' in obj:
      ans.version = obj['version']
    return ans
