# Copyright (c) 2020  University of Houston

# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

from __future__ import absolute_import

class LabserveError(Exception):
  def __init__ (self, code):
    super(LabserveError, self).__init__()
    self.code = code
    self.msg = ""

  def __str__ (self):
    return "<LabserveError [%d]: %s>" % (self.code, self.msg)

  def __json__ (self):
    return {"retcode" : self.code, "msg" : self.msg, "value" : None}


class UnsupportedVersionError(LabserveError):
  def __init__ (self, version):
    super(UnsupportedVersionError, self).__init__(1)
    self.version = version
    self.msg = "Unsupported file version: %s" % (self.version)

