# Copyright (c) 2018-2019  University of Houston Networking Lab

# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

from __future__ import absolute_import

import uuid

from .datafile import DataFile

class Scenario(DataFile):
  EXTENSION='.scen'

  def __init__ (self):
    super(Scenario, self).__init__()
    self.uuid = str(uuid.uuid4())
    self.version = 1

    self.uiname = None
    self.request = None
    self.sort = None
    self.slicename = None
    self.pre_build = None
    self.post_build = None
    self.topo_name = None

  def __json__ (self):
    obj = {}
    obj["version"] = self.version
    obj["uuid"] = self.uuid
    obj["uiname"] = self.uiname
    obj["request"] = self.request
    obj["sort"] = self.sort
    obj["slicename"] = self.slicename
    obj["pre-build"] = self.pre_build
    obj["post-build"] = self.post_build
    obj["topo-name"] = self.topo_name
    return obj

  @classmethod
  def jconstruct (cls, obj):
    scen = cls()
    if obj["version"] >= 1:
      if "uuid" in obj:
        scen.uuid = obj["uuid"]

      scen.uiname = obj["uiname"]
      scen.request = obj["request"]
      scen.sort = obj["sort"]
      scen.slicename = obj["slicename"]
      scen.topo_name = obj["topo-name"]
      scen.pre_build = obj["pre-build"]
      scen.post_build = obj["post-build"]

    return scen

